Index: /branches/playability/src/util/hud.cc
===================================================================
--- /branches/playability/src/util/hud.cc	(revision 10029)
+++ /branches/playability/src/util/hud.cc	(revision 10030)
@@ -236,5 +236,5 @@
 
   std::list<OrxGui::GLGuiWidget*>::iterator weaponWidget;
-  Vector2D pos(0.3, .7);
+  Vector2D pos(0.3, .9);
   for (weaponWidget = this->weaponsWidgets.begin(); weaponWidget != this->weaponsWidgets.end(); weaponWidget++, pos.x+=.2)
   {
Index: /branches/playability/src/world_entities/player.cc
===================================================================
--- /branches/playability/src/world_entities/player.cc	(revision 10029)
+++ /branches/playability/src/world_entities/player.cc	(revision 10030)
@@ -75,7 +75,7 @@
     this->playable = playable;
     this->_hud.setEnergyWidget(this->playable->getHealthWidget());
-    /*if (dynamic_cast<SpaceShip*>(this->playable))
+    if (dynamic_cast<SpaceShip*>(this->playable) != 0)
       this->_hud.setWeaponManager(&this->playable->getWeaponManager(), &dynamic_cast<SpaceShip*>(this->playable)->getWeaponManagerSecondary());
-    else*/
+    else
       this->_hud.setWeaponManager(&this->playable->getWeaponManager());
 
Index: /branches/playability/src/world_entities/space_ships/space_ship.cc
===================================================================
--- /branches/playability/src/world_entities/space_ships/space_ship.cc	(revision 10029)
+++ /branches/playability/src/world_entities/space_ships/space_ship.cc	(revision 10030)
@@ -145,17 +145,17 @@
 
   Weapon* wpRight1 = new LightBlaster ();
-  wpRight1->setName("Light Blaster Right");
+  wpRight1->setName("LightBlaster");
   Weapon* wpLeft1 = new LightBlaster ();
-  wpLeft1->setName("Medium Blaster Left");
+  wpLeft1->setName("LightBlaster");
 
   Weapon* wpRight2 = new MediumBlaster ();
-  wpRight2->setName("Medium Blaster Right");
+  wpRight2->setName("MediumBlaster");
   Weapon* wpLeft2 = new MediumBlaster ();
-  wpLeft2->setName("Medium Blaster Left");
-
-/*  Weapon* wpRight3 = new HeavyBlaster ();
-  wpRight3->setName("Heavy Blaster Right");
+  wpLeft2->setName("MediumBlaster");
+
+  Weapon* wpRight3 = new HeavyBlaster ();
+  wpRight3->setName("HeavyBlaster");
   Weapon* wpLeft3 = new HeavyBlaster ();
-  wpLeft3->setName("Heavy Blaster Left");*/
+  wpLeft3->setName("HeavyBlaster");
 
   Weapon* cannon = new SwarmLauncher();
@@ -168,6 +168,6 @@
   this->weaponMan.addWeapon( wpLeft2, 0, 2);
   this->weaponMan.addWeapon( wpRight2, 0, 3);
-/*  this->weaponMan.addWeapon( wpLeft3, 0, 4);
-  this->weaponMan.addWeapon( wpRight3, 0, 5);*/
+  this->weaponMan.addWeapon( wpLeft3, 0, 4);
+  this->weaponMan.addWeapon( wpRight3, 0, 5);
 
   this->secWeaponMan.addWeapon( cannon, 1, 0);
@@ -180,6 +180,6 @@
   wpRight2->requestAction(WA_ACTIVATE);
   wpLeft2->requestAction(WA_ACTIVATE);
-/*  wpRight3->requestAction(WA_ACTIVATE);
-  wpLeft3->requestAction(WA_ACTIVATE);*/
+  wpRight3->requestAction(WA_ACTIVATE);
+  wpLeft3->requestAction(WA_ACTIVATE);
 
   cannon->requestAction(WA_ACTIVATE);
Index: /branches/playability/src/world_entities/space_ships/space_ship.h
===================================================================
--- /branches/playability/src/world_entities/space_ships/space_ship.h	(revision 10029)
+++ /branches/playability/src/world_entities/space_ships/space_ship.h	(revision 10030)
@@ -56,5 +56,5 @@
     virtual void process(const Event &event);
 
-    inline WeaponManager getWeaponManagerSecondary() { return this->secWeaponMan; };
+    inline WeaponManager& getWeaponManagerSecondary() { return this->secWeaponMan; };
 
     //Functions for GUI
Index: /branches/playability/src/world_entities/weapons/weapon.cc
===================================================================
--- /branches/playability/src/world_entities/weapons/weapon.cc	(revision 10029)
+++ /branches/playability/src/world_entities/weapons/weapon.cc	(revision 10030)
@@ -516,5 +516,4 @@
     if (this->soundBuffers[WA_SHOOT].loaded())
       this->soundSource->play(this->soundBuffers[WA_SHOOT]);
-    this->updateWidgets();
     // fire
     this->energy -= this->minCharge;
@@ -522,4 +521,5 @@
     // setting up for the next state
     this->enterState(WS_SHOOTING);
+    this->updateWidgets();
   }
   else  // reload if we still have the charge